# Plugins

Plugins are an extension of Empire that allow for custom scripts to be loaded.
This allows anyone to build or add community projects to extend Empire functionality.
Plugins can be accessed from the Empire client or the API as long as the plugin follows
the [template example](https://github.com/BC-SECURITY/Empire/blob/master/empire/server/plugins/example.py). A list of Empire Plugins is located here.

## Empire Plugins

| Plugin Name                                                                  | Description                                                                                                                                                                                |                                                                                                              Preview                                                                                                              | Authors         | Sponsor Plugin |
| ---------------------------------------------------------------------------- | ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------ | :-------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------: | --------------- | -------------- |
| [Socks Proxy Server](https://github.com/BC-SECURITY/SocksProxyServer-Plugin) | Self-contained server for Invoke-SocksProxy.                                                                                                                                               |      [![image](https://user-images.githubusercontent.com/20302208/120247213-8ffa7100-c227-11eb-8a7a-5f0de195f2e9.gif)](https://user-images.githubusercontent.com/20302208/120247213-8ffa7100-c227-11eb-8a7a-5f0de195f2e9.gif)     | @Cx01N, @mjokic |                |
| [Chisel Server](https://github.com/BC-SECURITY/ChiselServer-Plugin)          | Runs chisels from the Empire CLI.                                                                                                                                                          |      [![image](https://user-images.githubusercontent.com/20302208/120249004-3c3f5600-c22e-11eb-962c-c9107c77b624.gif)](https://user-images.githubusercontent.com/20302208/120249004-3c3f5600-c22e-11eb-962c-c9107c77b624.gif)     | @kevin          |                |
| [AMSI Fail](https://github.com/BC-SECURITY/AmsiFail-Plugin)                  | The AMSI Fail Plugin calls the [AMSI.fail API](https://github.com/Flangvik/AMSI.fail) to generate and add a fresh AMSI Bypass to the Empire database.                                      |    [![client gif](https://user-images.githubusercontent.com/9831420/119946884-f2afec00-bf4b-11eb-9267-5aff2d45e4ba.gif)](https://user-images.githubusercontent.com/9831420/119946884-f2afec00-bf4b-11eb-9267-5aff2d45e4ba.gif)    | @Vinnybod       | X              |
| [MITRE ATT\&CK](https://github.com/BC-SECURITY/Attack-Plugin)                | The ATT\&CK plugin assists in better threat emulation in Empire by leveraging the MITRE ATT\&CK Framework for report generation and module management.                                     |  [![mitre\_attack](https://user-images.githubusercontent.com/20302208/122619115-8acd5c80-d044-11eb-8798-142afb07874f.gif)](https://user-images.githubusercontent.com/20302208/122619115-8acd5c80-d044-11eb-8798-142afb07874f.gif) | @Cx01N          | X              |
| [Advanced Reports](https://github.com/BC-SECURITY/Report-Generation-Plugin)  | Creates customizable PDF reports (Empire Report, Module Report, Master Log, Sessions, Credentials)                                                                                         | [![empire\_report](https://user-images.githubusercontent.com/20302208/122622654-36c77580-d04e-11eb-81fa-d0acc0ac5ece.gif)](https://user-images.githubusercontent.com/20302208/122622654-36c77580-d04e-11eb-81fa-d0acc0ac5ece.gif) | @Cx01N          | X              |
| [EternalBlue-Plugin](https://github.com/BC-SECURITY/EternalBlue-Plugin)      | EternalBlue-Plugin uses the EternalBlue exploit ([CVE-17-010](https://docs.microsoft.com/en-us/security-updates/securitybulletins/2017/ms17-010)) to perform remote code execution on SMB. |   [![eternalblue](https://user-images.githubusercontent.com/20302208/121796319-e1621300-cbcc-11eb-906d-dd73e9ea1035.gif)](https://user-images.githubusercontent.com/20302208/121796319-e1621300-cbcc-11eb-906d-dd73e9ea1035.gif)  | @Cx01N          | X              |
| [Nmap-Plugin](https://github.com/BC-SECURITY/Nmap-Plugin)                    | Nmap-Plugin gives a way to interface directly from Empire to [Nmap](https://nmap.org/) and send commands through [Python3-Nmap](https://github.com/nmmapper/python3-nmap).                 |      [![nmap](https://user-images.githubusercontent.com/20302208/120945236-1feb5f80-c6ed-11eb-9ca3-160c66d4c447.gif)](https://user-images.githubusercontent.com/20302208/120945236-1feb5f80-c6ed-11eb-9ca3-160c66d4c447.gif)      | @Cx01N          | X              |
| [Twilio-Plugin](https://github.com/BC-SECURITY/Twilio-Plugin)                | The Twilio Plugin is meant to show the possibilities of the Hooks feature implemented in Empire 4.1. It sends a text message every time an agent connects.                                 |                                                                                                                                                                                                                                   | @Vinnybod       |                |
| [denylist-plugin](https://github.com/BC-SECURITY/denylist-plugin)            | The purpose of this plugin is to block certain IP addresses from connecting to the server. It is to showcase the event-driven nature of the hook system.                                   |                                                                                                                                                                                                                                   | @Vinnybod       |                |
